Ext.define('DSS.addon.EventMailer', {

    extend : 'DSS.addon.Framework',

    config : {
        appName : 'Messages',
        appId : 'hleedit',
        appVersion : '1.0.0.0',
        appIcon : 'default_icon.png',
    },

    getHelp : function() {
        return Ext.create('Ext.Component', {
            loader : {
                url : 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad : true,
                disableCaching : false
            }
        });
    },

    getContent : function() {
        var me=this;
        
        var oConfig={
                defaultSortCol:'name',
                disabledProperty:'disabled',
                storeConfig: {
                    storeId : 'emailStore',
                    fields : [ {name:'disabled', sortType:'asBoolean'}, 
                               {name:'name', sortType:'asUCText'}, 
                               {name:'id'}, 
                               {name:'message', sortType:'asEmail'}, 
                               {name:'triggers', sortType:'asTrigger'}, 
                               { name: 'conditions',  sortType: 'asUCText' },
                               {name:'defaultFooter', sortType:'asBoolean'} ]
                },
                multiselect:true,
                columns: [{
                    header : _('Active'),
                    dataIndex : 'disabled',
                    resizable : false,
                    xtype: 'disabledcolumn', 
                    width : 50
                }, {
                    header : _('Name'),
                    dataIndex : 'name',
                    xtype: 'textcolumn', 
                    width : 200
                }, {
                    header : _('Trigger'),
                    dataIndex : 'triggers', 
                    maintainFlex : true,
                    flex : 1,
                    xtype: 'triggercolumn'
                },{
                    header : _('Message'),
                    dataIndex : 'message',
                    xtype:'emailcolumn',
                    flex : 1
                },{
                    header: _('Conditions'),
                    dataIndex: 'conditions', // alibi index
                    xtype: 'conditioncolumn',
                    maintainFlex: true,
                    flex: 1,
                    customRendererOptions:{hideEnabled:true,hideWeekdays:false,hideGenericSystemStates:false,hideZoneStates:false,hideTimeframe:false,filterSystemState:[],
                    	stateTitles:[{name:'daylight',value:true,title:_('grid_daylight_true')},{name:'daylight',value:false,title:_('grid_daylight_false')},
                    	             {name:'daynight',value:true,title:_('grid_daynight_true')},{name:'daynight',value:false,title:_('grid_daynight_false')},
                    	             {name:'panic',value:'1',title:_('grid_panic_active')},{name:'panic',value:'2',title:_('grid_panic_inactive')},
                    	             {name:'presence',value:'present',title:_('grid_presence_present')},{name:'presence',value:'absent',title:_('grid_presence_absent')},
                    	             {name:'fire',value:'1',title:_('grid_fire_active')},{name:'fire',value:'2',title:_('grid_fire_inactive')},
                    	             {name:'hail',value:'1',title:_('grid_hail_active')},{name:'hail',value:'2',title:_('grid_hail_inactive')},
                    	             {name:'wind',value:'1',title:_('grid_wind_active')},{name:'wind',value:'2',title:_('grid_wind_inactive')},
                    	             {name:'rain',value:'1',title:_('grid_rain_active')},{name:'rain',value:'2',title:_('grid_rain_inactive')},
                    	             {name:'alarm',value:'1',title:_('grid_alarm_active')},{name:'alarm',value:'2',title:_('grid_alarm_inactive')},
                    	             {name:'alarm2',value:'1',title:_('grid_alarm2_active')},{name:'alarm2',value:'2',title:_('grid_alarm2_inactive')},
                    	             {name:'alarm3',value:'1',title:_('grid_alarm3_active')},{name:'alarm3',value:'2',title:_('grid_alarm3_inactive')},
                    	             {name:'alarm4',value:'1',title:_('grid_alarm4_active')},{name:'alarm4',value:'2',title:_('grid_alarm4_inactive')},
                    	             {name:'holiday', value:'on',title:_('grid_holiday_on')},{name:'holiday', value:'off',title:_('grid_holiday_off')}]}
                }],     
                buttonText: {
                    newButton: _('New message'),
                    editButton: _('Edit message'),
                    enableButton:_('Activate message'),
                    disableButton:_('Deactivate message'),
                    testButton: _('Test message'),
                    deleteButton: _('Delete message')
                },
                editorConfig:{
                    title : _('Messageproperties'),
                    staticControls : [{
                        type : 'text',
                        label : _('Name'),
                        id : 'name'
                    }, {
                        type : 'hidden',
                        label : _('id'),
                        id : 'id'
                    }],
                    tabControls :  [{
                        tabLabel : _('Trigger'),
                        tabDescription : _('Choose the triggering activity for the message. You can choose more than one activity as trigger.'),
                        content : [ {
                            type : 'TriggerConfigurator',
                            id : 'triggers',
                            flex : true
                        } ]
                    }, {
                        tabLabel : _('Conditions'),
                        content : []
                    }, {
                        tabLabel : _('Message'),
                        tabDescription : _('Provide the Message, which will be send.'),
                        content : [ {
                            type : 'MessageControl',
                            id : 'message',
                            title : _('Message'),
                            flex : true
                        }/*, {
                            type : 'checkbox',
                            id : 'defaultFooter',
                            label : "Standardtext mit Beschreibung des ausl&ouml;senden Events anf&uuml;gen"
                        } */]
                    } , {
                        tabLabel : _('Conditions'),
                        tabDescription : _('Choose the conditions.'),
                        content : [{
                            type : 'ConditionConfigurator',
                            id : 'conditions',
                            conditions:[
                                        {type:'singleItem',title:_('state_daynight'),entry:[
                                              {type:'state',name:'daylight',value:true,title:Ext.String.format2(_('daynight_bright'),{
		                                            	duskTime:dss.staticDataModel.getDusk(),
		                                            	dawnTime:dss.staticDataModel.getDawn()
		                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_true'),{
		                                            	duskTime:dss.staticDataModel.getDusk(),
		                                            	dawnTime:dss.staticDataModel.getDawn()
		                                            })},
                                              {type:'state',name:'daylight',value:false,title:Ext.String.format2(_('daynight_dark'),{
	                                            	duskTime:dss.staticDataModel.getDusk(),
	                                            	dawnTime:dss.staticDataModel.getDawn()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_false'),{
	                                            	duskTime:dss.staticDataModel.getDusk(),
	                                            	dawnTime:dss.staticDataModel.getDawn()
	                                            })},
                                              {type:'state',name:'daynight',value:true,title:Ext.String.format2(_('daynight_day'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_true'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            })},
                                              {type:'state',name:'daynight',value:false,title:Ext.String.format2(_('daynight_night'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_false'),{
	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
	                                            	sunsetTime:dss.staticDataModel.getSunset()
	                                            })},
	                                            
	                                            ]},
                                        {type:'timeframe',title:_('Timeframe')},
                                        {type:'weekdays',title:_('Weekdays')},
                                        {type:'deviceState',title:_('automatic devices')},
                                        {type:'singleItem',title:_('state_presence'),entry: [
                                               {type:'state',name:'presence',value:'present',title:_('presence_present'),gridText:_('grid_presence_present')},
                                               {type:'state',name:'presence',value:'absent',title:_('presence_absent'),gridText:_('grid_presence_absent')}]},                                               
                                        {type:'singleItem',title:_('state_holiday'),entry: [
                                               {type:'state',name:'holiday',value:'on',title:_('holiday_on'),gridText:_('grid_holiday_on')},
                                               {type:'state',name:'holiday',value:'off',title:_('holiday_off'),gridText:_('grid_holiday_off')}]},
	                                   {type:'multiItem',title:_('weather trigger'),entry: [
	                                            {type:'state',name:'rain',value:'1',title:_('rain active'),gridText:_('grid_rain_active'),group:1},
	                                            {type:'state',name:'rain',value:'2',title:_('rain inactive'),gridText:_('grid_rain_inactive'),group:1},
	                                            {type:'state',name:'wind',value:'1',title:_('wind active'),gridText:_('grid_wind_active'),group:2},
	                                            {type:'state',name:'wind',value:'2',title:_('wind inactive'),gridText:_('grid_wind_inactive'),group:2},
	                                            {type:'state',name:'hail',value:'1',title:_('hail active'),gridText:_('grid_hail_active'),group:3},
	                                            {type:'state',name:'hail',value:'2',title:_('hail inactive'),gridText:_('grid_hail_inactive'),group:3}]},
	                                   {type:'multiItem',title:_('Security'),entry: [
	                                           {type:'state',name:'fire',value:'1',title:_('fire active'),gridText:_('grid_fire_active'),group:1},
	                                           {type:'state',name:'fire',value:'2',title:_('fire inactive'),gridText:_('grid_fire_inactive'),group:1},
	                                            {type:'state',name:'panic',value:'1',title:_('panic_active'),gridText:_('grid_panic_active'),group:2},
	                                            {type:'state',name:'panic',value:'2',title:_('panic_inactive'),gridText:_('grid_panic_inactive'),group:2},
	                                            {type:'state',name:'alarm',value:'1',title:_('alarm_active'),gridText:_('grid_alarm_active'),group:3},
	                                            {type:'state',name:'alarm',value:'2',title:_('alarm_inactive'),gridText:_('grid_alarm_inactive'),group:3},
	                                            {type:'state',name:'alarm2',value:'1',title:_('alarm2_active'),gridText:_('grid_alarm2_active'),group:4},
	                                            {type:'state',name:'alarm2',value:'2',title:_('alarm2_inactive'),gridText:_('grid_alarm2_inactive'),group:4},
	                                            {type:'state',name:'alarm3',value:'1',title:_('alarm3_active'),gridText:_('grid_alarm3_active'),group:5},
	                                            {type:'state',name:'alarm3',value:'2',title:_('alarm3_inactive'),gridText:_('grid_alarm3_inactive'),group:5},
	                                            {type:'state',name:'alarm4',value:'1',title:_('alarm4_active'),gridText:_('grid_alarm4_active'),group:6},
	                                            {type:'state',name:'alarm4',value:'2',title:_('alarm4_inactive'),gridText:_('grid_alarm4_inactive'),group:6}]},
                                        {type:'zonestate',title:_('ZoneState')}
                            ],
                            flex : true
                        }]
                    }]
                },
                listeners: {
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){    
                        
                        dss.raiseEvent('event-mailer', {
                            actions : 'save',
                            value : Ext.JSON.encode(values)
                        })
                        me.waitAndReload(grid);
                    },
                    'enableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        dss.raiseEvent('event-mailer', {
                            actions : 'enable',
                            id : Ext.JSON.encode(idVal)
                        });
                        me.waitAndReload(grid);
                     },
                    'disableEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        dss.raiseEvent('event-mailer', {
                            actions : 'disable',
                            id : Ext.JSON.encode(idVal)
                        })
                        me.waitAndReload(grid);
                    },
                    'deleteEntry':function (grid,entry){
                    	var idVal;
                    	if (entry.get!=null) {
                    		idVal=entry.get('id');
                    	} else {
                    		idVal=[];
                    		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                    			if (entry[iIndex]!=null)
                    				idVal.push(entry[iIndex].get('id'));
                    	}
                        dss.raiseEvent('event-mailer', {
                            actions : 'delete',
                            id : Ext.JSON.encode(idVal)
                        })
                        me.waitAndReload(grid);
                    },
                    'testEntry':function (grid,entry){
                        dss.raiseEvent('event-mailer', {
                            actions : 'test',
                            id : entry.get('id')
                        });
                    }
                }
        };
        
        return Ext.create('DSS.gridPanel', oConfig);
    },
    loadParameter : function(grid) {
    	grid.setStatus(_('Loading ...'));
        var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/event-mailer/values/*(*)/*(*)/*(*)/*(*)'
        });
        var result = Ext.JSON.decode(sString);
        
        oResultObject=dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                           {name:'id',type:'simple'},
                                                           {name:'disabled',type:'condition/enabled'},
                                                           {name:'message', type:'message'},
                                                           {name:'triggers',type:'trigger'},
                                                           {name: 'conditions', type: 'condition'}]);    
        if (oResultObject!=null) {
            grid.loadParameter(oResultObject);
        }
        grid.setStatus(_('Ready'));
    },
    waitAndReload : function(grid) {
    	grid.setStatus(_('Saving ...'));
        var me = this;
        var iSubscriptID = Math.floor(Math.random() * 100000000000);
        dss.ajaxSyncRequest('/json/event/subscribe', {
            subscriptionID : iSubscriptID,
            name : 'event-mailer-saved'
        });
        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
            subscriptionID : iSubscriptID,
            timeout : 60 * 1000
        }, function() {
            me.loadParameter(grid);
            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                subscriptionID : iSubscriptID,
                name : 'event-mailer-saved'
            });
        });
        
    }
});

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/event-mailer.po']);
    var EmailEdit = Ext.create('DSS.addon.EventMailer');
    EmailEdit.initPage();
});
